#pragma once

#include <vector>

#include "shapes.h"
#include "transform.h"

namespace VgMath{

class Scene{
public:
    std::vector<Sphere> sphere;
    void createRandom(int howManySpheres){
        sphere.clear();

        for (int i=0; i<howManySpheres; i++) {
            Sphere s;
            s.center = Point3::random(5) + Vector3(0,0,15);
            s.radius = randomBetween( 1, 3 );
            sphere.push_back( s );
        }
    }

};


inline bool intersect(const Ray& r, const Scene& s, Versor3 &n){
    return intersect( r, s.sphere[0] , n );
}


}; // end of namespace VgMath

