#include "point3.h"
#include "versor3.h"
#include "mat3.h"


using namespace VgMath;

// definition of the methods defined in vector3.h

Point3 Vector3::asPoint3() const{
    return Point3(x,y,z);
}

Versor3 Vector3::asVersor3() const{
    return Versor3(x,y,z);
}

Mat3 Mat3::rotX( Degrees alpha ){
    Scalar c,s;
    cossin(alpha,c,s);
    Mat3 res;
    res.setRowMajor(
       1, 0, 0,
       0,+c,+s,
       0,-s,+c
    );
    return res;
}

Mat3 Mat3::rotY( Degrees alpha ){
    Scalar c,s;
    cossin(alpha,c,s);
    Mat3 res;
    res.setRowMajor(
      +c, 0,-s,
       0, 1, 0,
      +s, 0,+c
    );
    return res;
}


Mat3 Mat3::rotZ( Degrees alpha ){
    Scalar c,s;
    cossin(alpha,c,s);
    Mat3 res;
    res.setRowMajor(
      +c,-s, 0,
      +s,+c, 0,
       0, 0, 1
    );
    return res;
}




